<template>
  <div style="width:100%;height:100%;">
      <button class="include-viewBtn mint-button mint-button--normal" @click.stop="showView">
        <!-- <i class="fa fa-th-large" aria-hidden="true"></i>
        标签页视图 -->
        <div class="btn-con">
          <div class="lf">
            <!-- <img calss="containing" src="../assets/images/containing.png" /> -->
            <i class="fa fa-th-large" aria-hidden="true"></i>
            {{tabViewDescript?tabViewDescript:tabParams.name}}
          </div>
          <div class="rg">
            <span class="rg-lf">{{tabParams.rowCount}}</span>
            <span class="rg-rg">
              <i class="fa fa-angle-right fa-lg"></i>
            </span>
          </div>
        </div>
      </button>
      <!-- {{field.docId}} -->
      <comm_dialog
        :title="$t('tabView')"
        :visible.sync="dialogVisible"
        v-bind="$attrs"
        v-on="$listeners"
        :modal="false"
        position="right"
        style="height: 100%;z-index:8888;"
        class="dept-tree"
        :id="openParams.id"
      >
        <view_delegate
          :openParams="{
            appId: openParams.appId, 
            actionContent: openParams.actionContent, 
            parentId:openParams.parentId, 
            isRelate:openParams.isRelate,
            showtype:'tab',
            formId:openParams.formId
          }"
          v-bind="$attrs"
          v-on="$listeners"
          @onAction="doCreate"
          @event="closeDialog"
          @getTabName="setTabName"
          @setTabNameAndCount="getTabNameAndCount"
          :showtype="openParams.showtype"
          :includeDisplayType="includeDisplayType"
        ></view_delegate>
      </comm_dialog>
  </div>
</template>

<script>
import Constant from "@/Constant.js";
import view_delegate from "@/components/view_delegate.vue";
import comm_dialog from "@/components/comm_dialog.vue";

export default {
  name: "o-tab-view",
  props: [
    "openParams", 
    "includeDisplayType", //包含元素或者选项卡为只读时的displayType=1,=4
  ],
  components: {
    view_delegate,
    comm_dialog
  },

  beforeDestroy() {
    //tab打开了视图，或者视图打开了表单，点击手机的返回键需要把DOM移除才能隐藏弹窗框
    document.getElementById(this.openParams.id).remove();//style.display = 'none';
  },

  data: function() {
    return {
      Constant,
      dialogVisible: false,
      view: {},
      tabParams:{},
      tabViewDescript:'',
    };
  },

  methods: {
    setTabName(value) {
      this.tabViewDescript = value;
    },
    getTabNameAndCount(params) {
      this.tabParams = params;
    },
    closeDialog() {
      this.dialogVisible = false;
    },
    doCreate(obj, showtype) {
      obj.showtype = showtype;
      this.$router.push({ name: "open", query: obj });
    },
    showView() {
      this.dialogVisible = true;
    }
  }
};
</script>

<style>
</style>
